﻿using Newtonsoft.Json;
using Pastel;
using RSND.Core.DbInternals;
using RSND.Core.Querying.Queries;

namespace RSND.Core;

public class Database
{
    List<Table> tables = new();

    public void CreateTable(Table query)
    {
        var matches = tables.FirstOrDefault(x => x.Name == query.Name);
        
        if (matches != null)
        {
            tables.Remove(matches);
        }
        
        tables.Add(query);
    }

    private static string GetRowsJson(Row[]? rows)
    {
        return JsonConvert.SerializeObject(new { Rows = rows });
    }
    
    public string GetValue(GetQuery? query)
    {
        Console.WriteLine(tables.Count.ToString().Pastel("#ff0000"));
        var table = query?.Table;
        var where = query?.Where;

        var split = where?.Split("|");
        var colName = split?[0];
        var condition = split?[1];
        var param = split?[2];

        if (query?.Select != "*") return "";
        
        
        var tableToReturn = tables.Find(x => x.Name == table);
        var rows = tableToReturn?.Rows?.Where(x => x.Columns?.FirstOrDefault(y => y.Data.Key == colName)?.Data.Value == param).ToArray();
        
        return GetRowsJson(rows);
    }

    public static void Loop()
    {
        while (true)
        {
            
        }
    }
}